<?php

header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");


require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/Database.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/data/Resume.php';


require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/auth/validate.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/core.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/BeforeValidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/ExpiredException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/SignatureInvalidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/JWT.php';
use \Firebase\JWT\JWT;



try{
    $database = new DataBase();
    $conn = $database->getConnection();
}catch(Exception $e){
    http_response_code(503);//service unavailable
    echo json_encode(array("message" => "unable to connect data base : ".$e->getMessage()));
    die();
}//end try connect to data base



$resume = new Resume($conn);
$data = json_decode(file_get_contents("php://input"));
$resume->phone = htmlspecialchars(strip_tags($data->user_phone));
    
if($resume->phoneExists()){
    http_response_code(400);//bad request
    echo json_encode(array("message"=>"signUp failed, phone already exist")); 
    die();
}//end check phone exists in database




    $resume->firstName = htmlspecialchars(strip_tags($data->first_name));
    $resume->lastName = htmlspecialchars(strip_tags($data->last_name));
    $resume->province=htmlspecialchars(strip_tags($data->user_province));
    $resume->city = htmlspecialchars(strip_tags($data->user_city)); 
    $resume->phone=htmlspecialchars(strip_tags($data->user_phone));
    $resume->email=htmlspecialchars(strip_tags($data->user_email));
    $resume->gender=htmlspecialchars(strip_tags($data->user_gender));
    $resume->maritalState = htmlspecialchars(strip_tags($data->user_maritalState));
    $resume->dateOfBirth = htmlspecialchars(strip_tags($data->user_dateOfBirth));
    $resume->educationDegree = htmlspecialchars(strip_tags($data->user_educationDegree)); 
    $resume->workExperience=htmlspecialchars(strip_tags($data->user_workExperience));
    $resume->skills=htmlspecialchars(strip_tags($data->user_skills));
    $resume->requestForMany=htmlspecialchars(strip_tags($data->user_requestForMany));
     $resume->description=htmlspecialchars(strip_tags($data->user_description));
     
    $resume->address=htmlspecialchars(strip_tags($data->user_address));
    $resume->rubika=htmlspecialchars(strip_tags($data->user_rubika));
    $resume->telegram=htmlspecialchars(strip_tags($data->user_telegram));
    $resume->instagram=htmlspecialchars(strip_tags($data->user_instagram));
    $resume->latitude=htmlspecialchars(strip_tags($data->location_latitude));
    $resume->longitude=htmlspecialchars(strip_tags($data->location_longitude));
    $resume->dateOfCreate=htmlspecialchars(strip_tags($data->date_create));


     
     
     
     $user_pic_select ="SELECT * FROM users WHERE phone=$resume->phone";

      $result = $conn->query($user_pic_select);



    while($user1 = $result->fetch()){
        
        $resume->pic=$user1["pic"]; 

 }



     

    if($resume->create()){
      
        
         // we need to re-generate jwt because user details might be different
    $token = array(
        "iss" => $iss,
        "aud" => $aud,
        "iat" => $iat,
        "nbf" => $nbf,
        "exp" => $exp,
        "data"=> array(
            "firstName" => $resume->firstName,
            "lastName" => $resume->lastName,
            "province" => $resume->province,
            "phone" => $resume->phone
        )
  
);
    $jwt = JWT::encode($token, $key);
    http_response_code(200);//OK
  
      echo json_encode(array("jwt" => $jwt));
    
    }else{
        http_response_code(503);//service unavailable
        echo json_encode(array("message" => "unable to create resume"));
    }//end if create user


?>