<?php
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");


require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/Database.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/data/User.php';



require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/core.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/BeforeValidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/ExpiredException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/SignatureInvalidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/JWT.php';
use \Firebase\JWT\JWT;



try{
    $database = new DataBase();
    $conn = $database->getConnection();
}catch(Exception $e){
    http_response_code(503);//service unavailable
    echo json_encode(array("message" => "unable to connect data base : ".$e->getMessage()));
    die();
}//end try connect to data base


$user = new User($conn);
$data = json_decode(file_get_contents("php://input"));

if(!empty($data->user_phone) &&
   !empty($data->first_name) &&
   !empty($data->last_name) &&
   !empty($data->user_province) ){

    $user->phone = htmlspecialchars(strip_tags($data->user_phone));
    
    if($user->phoneExists()){
        http_response_code(400);//bad request
        echo json_encode(array("message"=>"signUp failed, phone already exist")); 
        die();
    }//end check phone exists in database

    //XSS
    $user->firstName = htmlspecialchars(strip_tags($data->first_name));
    $user->lastName = htmlspecialchars(strip_tags($data->last_name));
    $user->province = htmlspecialchars(strip_tags($data->user_province)); 
    $user->pic ="profile_default.png";


    if($user->create()){
        
        $token = array(
        "iss" => $iss,
        "aud" => $aud,
        "iat" => $iat,
        "nbf" => $nbf,
        "exp" => $exp,
        "data"=> array(
            "firstName" => $user->firstName,
            "lastName" => $user->lastName,
            "province" => $user->province,
            "phone" => $user->phone
        )
    );
    http_response_code(200);//OK
    $jwt = JWT::encode($token, $key);
      http_response_code(201);//created
        echo json_encode(array("jwt" => $jwt));
      
    }else{
        http_response_code(503);//service unavailable
        echo json_encode(array("message" => "unable to create user"));
    }//end if create user

}else{
    http_response_code(400);//bad request
    echo json_encode(array("message" => "unable to create user. data is incomplete"));
}//end if check data


?>