<?php

header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");

require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/Database.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/data/Resume.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/data/User.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/auth/validate.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/auth/class.Utility.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/core.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/BeforeValidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/ExpiredException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/SignatureInvalidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/JWT.php';

use \Firebase\JWT\JWT;

$utility = new Utility();

// اتصال به پایگاه داده
try {
    $database = new Database();
    $conn = $database->getConnection();
} catch (Exception $e) {
    $utility->handleError(503, "اتصال به پایگاه داده امکان‌پذیر نیست: " . $e->getMessage());
    die();
}

// مسیر پوشه تصاویر
$image_path = $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/pictuers/';

// بررسی وجود دایرکتوری
if (!is_dir($image_path)) {
    $utility->handleError(404, "پوشه تصاویر یافت نشد: $image_path");
    die();
}

// دریافت نام تمام تصاویر از پایگاه داده
$query = "SELECT profile_picture, achievement_photo_1, achievement_photo_2, achievement_photo_3 FROM person_resume";
$stmt = $conn->prepare($query);
$stmt->execute();
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

// ایجاد آرایه‌ای برای نگه‌داری نام فایل‌های موجود در پایگاه داده
$existingImages = [];

foreach ($result as $row) {
    if ($row['profile_picture']) {
        $existingImages[] = basename($row['profile_picture']);
    }
    if ($row['achievement_photo_1']) {
        $existingImages[] = basename($row['achievement_photo_1']);
    }
    if ($row['achievement_photo_2']) {
        $existingImages[] = basename($row['achievement_photo_2']);
    }
    if ($row['achievement_photo_3']) {
        $existingImages[] = basename($row['achievement_photo_3']);
    }
}

// دریافت تمام تصاویر در پوشه
$filesInFolder = array_diff(scandir($image_path), ['..', '.']);

// مرور فایل‌های موجود در پوشه و حذف فایل‌هایی که در پایگاه داده نیستند
foreach ($filesInFolder as $file) {
    if (!in_array($file, $existingImages)) {
        $filePath = $image_path . $file;
        if (unlink($filePath)) {
            echo json_encode(["message" => "عکس $file با موفقیت حذف شد."]);
        } else {
            echo json_encode(["error" => "خطا در حذف عکس $file."]);
        }
    }
}

// اگر می‌خواهید بعد از بررسی تمام فایل‌ها پاسخ دهید
http_response_code(200);
echo json_encode(["message" => "عملیات بررسی تصاویر به پایان رسید."]);

?>
