<?php
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");

require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/Database.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/data/User.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/core.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/BeforeValidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/ExpiredException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/SignatureInvalidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/JWT.php';


use \Firebase\JWT\JWT;

$headers = getallheaders();
if (!isset($headers['JWT_KEY']) || $headers['JWT_KEY'] !== JWT_KEY) {
    http_response_code(403); // Forbidden
    echo json_encode(array("message" => "Access denied."));
    die();
}

try {
    $database = new DataBase();
    $conn = $database->getConnection();
} catch (Exception $e) {
    http_response_code(503); // Service unavailable
    echo json_encode(array("message" => "Unable to connect to database: " . $e->getMessage()));
    die();
}

$user = new User($conn);
$data = json_decode(file_get_contents("php://input"));

if (empty($data->user_phone)) {
    http_response_code(400); // Bad request
    echo json_encode(array("message" => "Phone not found."));
    die();
}

$user->phone = htmlspecialchars(strip_tags($data->user_phone));

if ($user->phoneExists($user->phone)) {
    $token = [
        "iss" => ISSUER,
        "aud" => AUDIENCE,
        "iat" => ISSUED_AT,
        "nbf" => NOT_BEFORE,
        "exp" => EXPIRATION_TIME,
        "data" => [
            "user_phone" => $user->phone
        ]
    ];
    http_response_code(200); // OK
    $jwt = JWT::encode($token, JWT_KEY);
    http_response_code(201); // Created
    echo json_encode(array("result" => $jwt));
} else {
    echo json_encode(array("result" => "notPhoneExists"));
}
?>