<?php

require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/auth/class.Utility.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/config/core.php'; 
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/BeforeValidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/ExpiredException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/SignatureInvalidException.php';
require_once $_SERVER['DOCUMENT_ROOT'].'/jobfinder/src/libs/php-jwt-master/src/JWT.php';

use \Firebase\JWT\JWT;

$utility = new Utility();

$token = $utility->getToken();

if (!empty($token)) {
    try {
        $decoded = JWT::decode($token, JWT_KEY, ['HS256']);
        
        $newToken = [
            "iss" => ISSUER,
            "aud" => AUDIENCE,
            "iat" => time(),
            "nbf" => time(),
            "exp" => time() + 3600,
            "data" => $decoded->data
        ];

        $jwt = JWT::encode($newToken, JWT_KEY);
        
        http_response_code(200);
      
    } catch (\Firebase\JWT\ExpiredException $e) {
        http_response_code(401);
        echo json_encode(array(
            "message" => "توکن منقضی شده است.",
            "error" => $e->getMessage()
        ));
    } catch (\Firebase\JWT\SignatureInvalidException $e) {
        http_response_code(401);
        echo json_encode(array(
            "message" => "امضای توکن نامعتبر است.",
            "error" => $e->getMessage()
        ));
    } catch (\Firebase\JWT\BeforeValidException $e) {
        http_response_code(401);
        echo json_encode(array(
            "message" => "توکن هنوز معتبر نشده است.",
            "error" => $e->getMessage()
        ));
    } catch (Exception $e) {
        http_response_code(401);
        echo json_encode(array(
            "message" => "دسترسی غیرمجاز.",
            "error" => $e->getMessage()
        ));
    }
} else {
    http_response_code(401);
    echo json_encode(array(
        "message" => "دسترسی غیرمجاز.",
        "error" => "توکن یافت نشد."
    ));
}

?>