<?php

class Admin {
    private $conn;
    private $table_name = "admins";

    public $id;
    public $full_name;
    public $phone;
    public $user_name;
    public $password;
    public $access_level;

    public function __construct($db) {
        $this->conn = $db;
    }

    // بررسی شماره مدیر
    public function isManager($phone) {
        $query = "SELECT access_level FROM " . $this->table_name . " WHERE phone = ? LIMIT 1";
        $stmt = $this->conn->prepare($query);
        $stmt->bindParam(1, $phone);
        $stmt->execute();

        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        return ($row && $row['access_level'] == 1); // سطح دسترسی 1 یعنی مدیر
    }

    // اضافه کردن ادمین جدید
    public function addAdmin($fullName, $phone, $userName, $password, $accessLevel) {
        $query = "INSERT INTO " . $this->table_name . " (full_name, phone, user_name, password, access_level) 
                  VALUES (:full_name, :phone, :user_name, :password, :access_level)";
        $stmt = $this->conn->prepare($query);

        $stmt->bindParam(":full_name", $fullName);
        $stmt->bindParam(":phone", $phone);
        $stmt->bindParam(":user_name", $userName);
        $stmt->bindParam(":password", password_hash($password, PASSWORD_BCRYPT)); // هش کردن رمز عبور
        $stmt->bindParam(":access_level", $accessLevel);

        return $stmt->execute();
    }
}
?>
