<?php

class User{

    private $conn;
    
    private $id;
    public $phone;
     public $referralCode;
    public $firstName;
    public $lastName;
    public $province;
    public $city;
    public $pic;
  
    public function __construct($conn){
        $this->conn = $conn;
    }

    public function create(){
        $query = "INSERT INTO users SET phone=:ph, firstName=:fa, lastName=:la, province=:pr, pic=:pi, city=:ci";
		
		$stmt = $this->conn->prepare($query);
        $stmt->bindParam(':ph', $this->phone);
		$stmt->bindParam(':fa', $this->firstName);
		$stmt->bindParam(':la', $this->lastName);
		$stmt->bindParam(':pr', $this->province);
        $stmt->bindParam(':pi', $this->pic);
        $stmt->bindParam(':ci', $this->city);

		
		if($stmt->execute()) return true;
        
		//print_r($stmt->errorInfo());
		return false;
    }
    

  
public function createUser() {
    error_log("Phone: " . $this->phone); // چاپ شماره تلفن
    error_log("Referral Code: " . $this->referralCode); // چاپ کد رفرال

    $query = "INSERT INTO users (phone, referral_code) VALUES (:phone, :referral_code)";
    $stmt = $this->conn->prepare($query);

    $stmt->bindParam(":phone", $this->phone);
    $stmt->bindParam(":referral_code", $this->referralCode); 

    if ($stmt->execute()) {
        return true;
    } else {
        print_r($stmt->errorInfo()); // چاپ خطاهای دیتابیس
        return false;
    }
}

 public function phoneExists($phone) {
    $query = "SELECT id FROM users WHERE phone = :phone LIMIT 1";
    $stmt = $this->conn->prepare($query);
    $stmt->bindParam(":phone", $phone);
    $stmt->execute();
    return $stmt->rowCount() > 0;
}

    public function idExists(){
        $query = "SELECT * FROM users WHERE user_id = ?";

        $stmt = $this->conn->prepare($query);
        $stmt->bindParam(1, $this->id);
        $stmt->execute();
        $num = $stmt->rowCount();

        if($num > 0){
            $row = $stmt->fetch(PDO::FETCH_ASSOC);
            extract($row);

            $this->firstName = $first_name;
            $this->lastName = $last_name;
            $this->email = $email;
            $this->pass = $pass;

            return true;
        }//end if num > 0
        return false;
    }

    public function update(){
        $query = "UPDATE users SET  firstName=:fa, lastName=:la,  province=:pr, city=:ci, pic=:pi WHERE phone=:ph";

        $stmt = $this->conn->prepare($query);
        $stmt->bindParam(":ph", $this->phone);
        $stmt->bindParam(":fa", $this->firstName);
        $stmt->bindParam(":la", $this->lastName);
        $stmt->bindParam(":pr", $this->province);
        $stmt->bindParam(":ci", $this->city);
         $stmt->bindParam(":pi", $this->pic);

        if($stmt->execute()) return true;
        
        return false;
    }
    
    public function updateProfileImage(){
        $query = "UPDATE users SET pic=:pi WHERE phone=:ph" ;
  
          $stmt = $this->conn->prepare($query);
         
          
          $stmt->bindParam(':ph', $this->phone, PDO::PARAM_STR);
          $stmt->bindParam(':pi', $this->pic, PDO::PARAM_STR);


          
          if($stmt->execute()) return true;
          
          return false;
      }

}
